{**********************************************************}
{**              Sample for THEXVIEWER                   **}
{**              Main - Unit                             **}
{**********************************************************}
UNIT htu;
{**********************************************************}
INTERFACE
{**********************************************************}
USES
  Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,
  Dialogs,StdCtrls,Menus,ComCtrls,RPHexView10,RPHexRuler,
  RPNewScrollU;
{**********************************************************}
TYPE
  TForm1 = Class(TForm)
    MainMenu1  : TMainMenu;
    Datei1     : TMenuItem;
    ffnen1     : TMenuItem;
    N1         : TMenuItem;
    Beenden1   : TMenuItem;
    Ansicht1   : TMenuItem;
    Hintergrundfarbe1: TMenuItem;
    Schriftfarbe1    : TMenuItem;
    N2         : TMenuItem;
    Schriftart1: TMenuItem;
    OpenDlg    : TOpenDialog;
    ColorDlg   : TColorDialog;
    FontDlg    : TFontDialog;
    StatusBar1 : TStatusBar;
    Info1: TMenuItem;
    Information1: TMenuItem;
    HexViewer1: THexViewer;
    VHexRuler1: TVHexRuler;
    HHexRuler1: THHexRuler;
    PopMenu1: TPopupMenu;
    ShowactiveFileName1: TMenuItem;
    ShowactiveFileSize1: TMenuItem;
    N3: TMenuItem;
    ShowRangeLine1: TMenuItem;
    Print1: TMenuItem;
    Goto1: TMenuItem;
    Hilfe1: TMenuItem;
    procedure ffnen1Click(Sender: TObject);
    procedure Hintergrundfarbe1Click(Sender: TObject);
    procedure Schriftfarbe1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Schriftart1Click(Sender: TObject);
    procedure Information1Click(Sender: TObject);
    procedure HexViewer1CPosChange(Sender: TObject);
    procedure HexViewer1VertScroll(Sender: TObject);
    procedure HexViewer1HorzScroll(Sender: TObject);
    procedure ShowactiveFileName1Click(Sender: TObject);
    procedure ShowactiveFileSize1Click(Sender: TObject);
    procedure ShowRangeLine1Click(Sender: TObject);
    procedure PopMenu1Popup(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Goto1Click(Sender: TObject);
    procedure Hilfe1Click(Sender: TObject);
    procedure HexViewer1NewFileDroped(Sender: TObject);
  private

  public
    { Public-Deklarationen }
  end;
{**********************************************************}
var
  Form1: TForm1;
{**********************************************************}
IMPLEMENTATION
{**********************************************************}
{$R *.DFM}
USES
 HTA,RPGoToU;
{**********************************************************}
procedure TForm1.ffnen1Click(Sender: TObject);
begin
  if OpenDlg.Execute then
   begin
     HexViewer1.SetFileName(OpenDlg.FileName);
     StatusBar1.Panels.Items[0].Text:= IntToStr(HexViewer1.GetHexFileSize) +
                                       ' Byte'
   end;
end;
{**********************************************************}
procedure TForm1.Hintergrundfarbe1Click(Sender: TObject);
begin        { setup colordlg }
  ColorDlg.Color:= HexViewer1.Color;
  if ColorDlg.Execute then
   begin
     HexViewer1.Color:= ColorDlg.Color;
     HHexRuler1.Color:= ColorDlg.Color;
     VHexRuler1.Color:= ColorDlg.Color;
   end;
end;
{**********************************************************}
procedure TForm1.Schriftfarbe1Click(Sender: TObject);
begin        { setup colordlg }
  ColorDlg.Color:= HexViewer1.Font.Color;
  if ColorDlg.Execute then
   begin
     HexViewer1.Font.Color:= ColorDlg.Color;
     HHexRuler1.Font.Color:= ColorDlg.Color;
     VHexRuler1.Font.Color:= ColorDlg.Color;
   end;
end;
{**********************************************************}
procedure TForm1.Beenden1Click(Sender: TObject);
begin
  Close;
end;
{**********************************************************}
procedure TForm1.Schriftart1Click(Sender: TObject);
begin
  FontDlg.Font:= HexViewer1.Font; { Setup fonddlg                }
  if FontDlg.Execute then  { Only fonts with fsPitch             }
   begin                   { when not then THEXVIEWER set it     }
     HexViewer1.Font:= FontDlg.Font;
     HHexRuler1.Font:= FontDlg.Font;
     VHexRuler1.Font:= FontDlg.Font;
   end;                    { and NOT (fsUnderLine + fsStrikeOut) }
end;
{**********************************************************}
procedure TForm1.Information1Click(Sender: TObject);
var
 About: TAboutDlg;
begin
  About:= TAboutDlg.Create(Self);
  About.ShowModal;
  About.Free;
end;
{**********************************************************}
procedure TForm1.HexViewer1CPosChange(Sender: TObject);
begin
  StatusBar1.Panels[1].Text:= 'CaretPos : ' +
                              IntToStr(HexViewer1.CaretPosX) + ', ' +
                              IntToStr(HexViewer1.CaretPosY) +
                              '  /  FilePos: ' + IntToHex(HexViewer1.CaretPosY *
                              16 + HexViewer1.CaretPosX,8) + 'h';
end;
{**********************************************************}
procedure TForm1.HexViewer1VertScroll(Sender: TObject);
begin
  VHexRuler1.UpDateRuler;
end;
{**********************************************************}
procedure TForm1.HexViewer1HorzScroll(Sender: TObject);
begin
  HHexRuler1.UpDateRuler;
end;
{**********************************************************}
procedure TForm1.ShowactiveFileName1Click(Sender: TObject);
begin
  MessageDlg('Filename: '+ HexViewer1.GetFileName,
             mtInformation,[mbOk],0);
end;
{**********************************************************}
procedure TForm1.ShowactiveFileSize1Click(Sender: TObject);
begin
  MessageDlg('Filesize: '+ IntToStr(HexViewer1.GetHexFileSize) +
             ' Byte',mtInformation,[mbOk],0);
end;
{**********************************************************}
procedure TForm1.ShowRangeLine1Click(Sender: TObject);
begin
  HexViewer1.ShowRangeLine:= NOT HexViewer1.ShowRangeLine;
end;
{**********************************************************}
procedure TForm1.PopMenu1Popup(Sender: TObject);
begin
  ShowRangeLine1.Checked:= HexViewer1.ShowRangeLine;
end;
{**********************************************************}
procedure TForm1.Print1Click(Sender: TObject);
begin
  Form1.Print;
end;
{**********************************************************}
procedure TForm1.Goto1Click(Sender: TObject);
var
 Dlg: TForm3;
begin
  Dlg:= TForm3.Create(Self);
  Dlg.ED1.Text:= IntToStr(HexViewer1.CaretPosX);
  Dlg.ED2.Text:= IntToStr(HexViewer1.CaretPosY);
  if Dlg.ShowModal = mrOk then
   HexViewer1.SetCaretTo(StrToInt(Dlg.ED1.Text),
                         StrToInt(Dlg.ED2.Text));
  Dlg.Free;
end;
{**********************************************************}
procedure TForm1.Hilfe1Click(Sender: TObject);
begin
  WinHelp(Handle,'THV.HLP',Help_Index,0);
end;
{**********************************************************}
procedure TForm1.HexViewer1NewFileDroped(Sender: TObject);
begin
  StatusBar1.Panels.Items[0].Text:= IntToStr(HexViewer1.GetHexFileSize) +
                                    ' Byte';
end;
{**********************************************************}
end.
{**********************************************************}
